#include <sys\stat.h>
#include <io.h>
#include <math.h>
#include <fcntl.h>
#include <process.h>
#include <conio.h>
#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>

/* Struttura usata come pagina secondaria */
static unsigned char pagina1[320][200];


/* Prototipi delle funzioni usate */
void  load_image();      /* Carica da disco una immagine            */
void  upload_image();    /* Copia su video il contenuto in memoria  */
void  init_graph();      /* Pone il sistema in grafica              */
void  close_graph();     /* Chiude la pagina grafica                */
void  equalizza();       /* Equalizzazione dell' istogramma         */
void  remapping();       /* Rimappamento dei livelli di grigio      */
void  download_image();  /* Copia il contenuto del video in memoria */
void  mediano();         /* Realizza il filtro mediano              */
int   quicksort();       /* Ovvio utilizzo                          */
void  media();	  	 /* Realizza il filtro a media mobile	   */

/* File che contengono le funzioni dichiarate nei prototipi */
#include "funzioni.c"
#include "istogr.c"
#include "loadsave.c"
#include "equaliz.c"
#include "remapp.c"
#include "mediano.c"
#include "quick.c"
#include "media.c"

/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*                  RABELLINO SERGIO SOFTWARE ENGINEERING                  */
/*                                                                         */
/*            Copyright  16 maggio 1991      Elaborazione di immagini      */
/***************************************************************************/

void main()
{
 unsigned char scelta;
 do
  {

    /* menu' principale */
    clrscr();
    printf("         ELABORAZIONE  DI IMMAGINI in Bianco e Nero\n");
    printf("\n");
    printf("      Rabellino Sergio Software Engineering \n");
    printf("\n");
    printf("\n");
    printf("1)  Caricamento di una immagine\n");
    printf("2)  Visualizzazione dell' immagine presente in memoria\n");
    printf("3)  Istogramma dei livelli di grigio in scala logaritmica\n");
    printf("4)  Equalizzazione dell' istogramma\n");
    printf("5)  Filtraggio mediano a passo variabile\n");
    printf("6)  Filtraggio a media mobile\n");
    printf("7)  Salvataggio dell' immagine elaborata\n");
    printf("8)  Rimappamento dei livelli di grigio con LUT standard\n");
    printf("0)  Uscita dal programma\n");
    printf("\n\n    Introduci la tua scelta : ");
    scelta = getch();

    if (scelta == '1') load_image();
    if (scelta == '2')
      {
	init_graph();
	upload_image();
	getch();
	close_graph();
      }
    if (scelta == '3') istogramma();
    if (scelta == '4') equalizza();
    if (scelta == '5') mediano();
    if (scelta == '6') media();
    if (scelta == '7') save_image();
    if (scelta == '8') remapping();
  }
  while (scelta != '0');

}


void upload_image()
{
 int x,y;
  /* funzione che riporta sullo schermo il contenuto della pagina in memoria */

  for (y=0;y<200;++y)
    for (x=0;x<320;++x)
	  putpixel(x,y,pagina1[x][y]);

}

void  download_image()
{
  int x,y;
  /* funzione che copia in memoria l'immagine presente sullo schermo */

  for (y=0;y<200;++y)
    for (x=0;x<320;++x)
      pagina1[x][y]=getpixel(x,y);
 }
